//	Essai de stratgie :
//	Avance sur le ligne 400mm
//	S'orienter en pi 
//	Affich le tlmetre
		
	StartHorloge();														// Dmarre le chrono sur 90 secondes
	Force_Propulsion(2910, 165, 2822);									// Initialise la position initiale du robot
	Commande_Rouleaux(90, 90);											// Met les rouleaux en marche






// ------------------------------------------------------------------
// Phase 1 : les deux balles bleues sur la table
//

	printf ("Ph 1 : Trajectoire\n");

	GotoXY_Propulsion(2804, 200, 50);									// Se place pour mesurer les positions des balles
	while (Etat_Propulsion ()!='a');				
		
	Angle_Propulsion (-PI,12);											// S'oriente parallle au bord de la table (approche grossire)
	while (Etat_Propulsion ()!='a');				

	Angle_Propulsion (-PI,1);											// S'orienter vers la 2eme balle (approche fine)
	while (Etat_Propulsion ()!='a');
	
	Delay10KTCYx(50);													// Tempo avant de faire la mesure de distance

	i=0;																// Nombre de mesure
	do																	
	{
		
		MesureTelemetre=Moyenne_Telemetre150cm(500);					// Effectue des mesures			
//		printf ("%d\n",MesureTelemetre);
		i++;															// Incrmente le nombre de mesures
	}
	while (MesureTelemetre>20 && MesureTelemetre<80 && i<100);			// Jusqu' ce que l'on obtienne une valeur discriminante ou que l'on ai fait 150 mesures
	
			
	if (MesureTelemetre>176)											// La balle est proche ...
		config=1;														// ... on est dans la config 1
	else
		if (MesureTelemetre>60)	//90 ... a voir !						// La balle est loin ... 
			config=2;													// ... on est dans la config 2
		else 															// Il n'y a pas de balle ... 
			config=3;													// ...on est dans la config 3
						
	printf ("Telem=%d Config=\n",MesureTelemetre,config);	
	
	switch (config)
	{
		case 1 :	Angle_Propulsion (2.3,30);							// S'oriente vers la 1ere balle
					while (Etat_Propulsion ()!='a');

					GotoXY_Propulsion(2200, 680, 100);					// Va chercher la balle fixe
					while (Etat_Propulsion ()!='a');

					Angle_Propulsion (-PI/2.0,30);						// S'orienter vers la 2eme balle
					while (Etat_Propulsion ()!='a');					// Attend la fin du mouvement

					GotoXY_Propulsion(2200, 350, 100);					// va chercher la 2me balle
					while (Etat_Propulsion ()!='a');

					break;

		case 2 :	Angle_Propulsion (2.822,20);							// S'oriente vers la 1ere balle
					while (Etat_Propulsion ()!='a');

					GotoXY_Propulsion(2200, 390, 100);						// Va chercher la balle fixe
					while (Etat_Propulsion ()!='a');
	
					Angle_Propulsion (-PI+0.34,20);							// S'oriente vers la 2eme balle
					while (Etat_Propulsion ()!='a');

					GotoXY_Propulsion(1800, 205, 100);						// Va la chercher
					while (	Etat_Propulsion ()!='a' &&						// Arrte le mouvement si c'est termin
							Telemetre_Avant_Droit()<DISTANCE_OBSTACLE &&	// Pas d'obstacle  gauche
							Telemetre_Avant_Gauche()<DISTANCE_OBSTACLE);	// Pas d'obstacle  droite				
							
					break;
					

		case 3 :	Angle_Propulsion (2.822,20);							// S'oriente vers la 1re balle
					while (Etat_Propulsion ()!='a');

					GotoXY_Propulsion(2200, 400, 100);						// Va chercher la balle fixe
					while (Etat_Propulsion ()!='a');
	
					Angle_Propulsion (-PI,20);								// S'oriente vers la 3eme balle
					while (Etat_Propulsion ()!='a');

					GotoXY_Propulsion(1800, 380, 100);						// va la chercher
					while (	Etat_Propulsion ()!='a' &&						// Arrte le mouvement si c'est termin
							Telemetre_Avant_Droit()<DISTANCE_OBSTACLE &&	// Pas d'obstacle  gauche
							Telemetre_Avant_Gauche()<DISTANCE_OBSTACLE);	// Pas d'obstacle  droite
					break;

		default	:	printf("Err"); 
	}
	





	
// ------------------------------------------------------------------
// Phase 2 : 3 balles blanches au distributeur
//

	printf ("Ph 2 : Distri blanc\n");
	
	GotoXY_Propulsion(	2100, Y_DISTRI_BLANC_BLEU, -40 );			// Aprs, on recule pour se placer face au distributeur
	while (Etat_Propulsion ()!='a' && NbBalles_Barillet(BLANCHE)<3);	// On arrte si on a les 3 balles blanches						
		
	Angle_Propulsion (0,25);											// S'oriente perpendiculaire  la largeur de la table ...
	while (Etat_Propulsion ()!='a' && NbBalles_Barillet(BLANCHE)<3);	// ... pour tre face au distributeur
	
	GotoXY_Propulsion(	3000, Y_DISTRI_BLANC_BLEU-50, 50 );				// Avance en face du distributeur
	while (	Etat_Propulsion ()!='g' &&									// On arrte si on est bloqu ...
			Etat_Propulsion ()!='a' && 									// ... ou si on est arriv (l il y a un problme !)...
			X_Propulsion ()<2550 &&										// ... ou on est proche du distributeur
			NbBalles_Barillet(BLANCHE)<3);								// ... ou si on a les 3 balles blanches
	Distributeur_Blanc_Bleu(3,-50);										// Prends 3 balles dans le distributeur blanc du ct bleu (avec une triche pour alligner le robot)
	






// ------------------------------------------------------------------
// Phase 2 bis : On fait le complment de balles bleues au distributeur
//
	printf ("Ph 2b: Distri bleu\n");

	if (NbBalles_Barillet(BLEUE)<2 && NbBalles_Barillet(TOUTES)<5) 		// Si on a pas les deux balles bleues et qu'il reste de la place
	{
		GotoXY_Propulsion(2300, 600, -50);								// On recule dans l'alignement du distributeur
		while (Etat_Propulsion ()!='a');
				
		Angle_Propulsion (-PI/2.0,25);									// S'oriente en face du distributeur
		while (Etat_Propulsion ()!='a');
		
		GotoXY_Propulsion(2300, 0, 50);									// Avancer vers le distributeur en avant
		while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
				Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
				Y_Propulsion ()>440 &&									// ... ou on est proche du distributeur
				NbBalles_Barillet(BLEUE)<2);							// ... ou si on a les 2 balles bleues
		Stop_Propulsion();												// On arrte les moteurs
		Distributeur_Bleu(2);											// Prends deux balles dans le distributeur
	}







// ------------------------------------------------------------------
// Phase 3 : 1er dpose des balles 
//	

	printf ("Ph 3 : Depose\n");
	GotoXY_Propulsion(	2300, Y_DISTRI_BLANC_BLEU, -80 );				// On recule au point de dpart
	while (	Etat_Propulsion ()!='g' &&									// On arrte si on est bloqu ...
			Etat_Propulsion ()!='a' && 									// ... ou si on est arriv (l il y a un problme !)...
			Telemetre_Arriere_Droit()<DISTANCE_OBSTACLE &&				// ... ou si il y a un obstacle  droite ...
			Telemetre_Arriere_Gauche()<DISTANCE_OBSTACLE);				// ... ou  gauche
	Commande_Rouleaux(-60, -60);										// Inverse le sens des rouleaux
	Goto_Conteneur (1000);												// Va au conteneur standard
	Depose_Balles (BLEUE);												// Dpose les balles dans le conteneur
	Commande_Rouleaux(90, 90);											// On fait tourner les rouleaux pour  nouveau attraper les balles
	
	
	
	
// ------------------------------------------------------------------
// Phase 4 : Localisation de l'adversaire et choix de la stratgie
//	
	
	config=1;															// Config 1 par dfaut, on retourne de notre ct
	
		//while (!Joy_Sw())
		//printf ("%d %d\n",Angle_Robot_Adverse(), Distance_Robot_Adverse());
		
	if (Angle_Robot_Adverse()>160 && Distance_Robot_Adverse()!=0)		// Si on sait ou est l'adversaire et qu'il est de notre ct
//		!Balles_Blanche_Adverce )									741	// On n'est pas encore allez chercher des balles chez lui
		config=2;														// On va lui prendre ses balles
	

	
	switch (config)
	{
		case 1 : 	printf ("Ph 4a: Chez nous\n");						// Config 1: on rentre au bercaille
					Goto_Cote_Bleu ();								// On va vers nos distributeurs
					
					if(	Distance_Robot_Adverse())
					{
						if ((Angle_Absolu_Robot_Adverse()<PI/4.0) && (Angle_Robot_Adverse()>-PI/4.0))
						{
							GotoXY_Propulsion(500,750,-100);									// On va lui piquer des blanches
							while (	Etat_Propulsion ()!='a' );	
					
							Angle_Propulsion (PI,25);											// S'oriente perpendiculaire  la largeur de la table ...
							while (Etat_Propulsion ()!='a' && NbBalles_Barillet(BLANCHE)<2);	// ... pour tre face au distributeur
	
							GotoXY_Propulsion(0,750,25);										// Longe le conteneur pour venir defendre
							while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 						// Soit on a les switchs
									&& Etat_Propulsion()!='g');									// Soit on est bloqu
					
							if (Recal_Avant())
								Force_Propulsion(234, Y_Propulsion (), 3141);
						
							Distributeur_Blanc_Rouge (2,0);	
							Goto_Cote_Bleu_Arriere ();		
							
						}							
					}
						
						
					if (!(Distance_Robot_Adverse()!=0 &&									// Que l'on voit le robot adverse
						Angle_Absolu_Robot_Adverse()<0 &&									// Est qu'il est pas dans le coin
					 	Angle_Absolu_Robot_Adverse()>-PI/2.0))					
					{
						GotoXY_Propulsion (2650,350,60);									// Avance au point de recalage
						while (Etat_Propulsion ()!='a');
				
						Recal_Cote_Bleu ();													// Recale le robot en X, Y et en Psi
					
						GotoXY_Propulsion(2500,750,-60);									// Recule dans l'axes des distributeurs
						while (Etat_Propulsion ()!='a');
					}

					
			
					
					if (NbBalles_Barillet(BLANCHE)<2)
					{
						Angle_Propulsion (0,25);							// S'oriente perpendiculaire  la largeur de la table ...
						while (Etat_Propulsion ()!='a'); 						// ... pour tre face au distributeur
						

						GotoXY_Propulsion(	3000, 750, 50 );				// Avance en face du distributeur
						while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 
							&& Etat_Propulsion()!='g' &&
							X_Propulsion()<2600);	
												
						GotoXY_Propulsion(	3000, 750, 25 );				// Avance en face du distributeur
						while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 
							&& Etat_Propulsion()!='g');	
							
						Distributeur_Blanc_Bleu(2,0);						// Prends 2 balles dans le distributeur blanc du ct bleu
					}
	
					if (NbBalles_Barillet(BLEUE)<3 && NbBalles_Barillet(TOUTES)<5) 		// Si on a pas les trois balles bleues et qu'il reste de la place
					{
						GotoXY_Propulsion(2300, 600, -50);								// On recule dans l'alignement du distributeur
						while (Etat_Propulsion ()!='a');
				
						Angle_Propulsion (-PI/2.0,25);									// S'oriente en face du distributeur
						while (Etat_Propulsion ()!='a');
		
						GotoXY_Propulsion(2300, 0, 50);									// Avancer vers le distributeur en avant
						while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
								Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
								Y_Propulsion ()>440 &&									// ... ou on est proche du distributeur
								NbBalles_Barillet(BLEUE)<3);							// ... ou si on a les 3 balles blanches
						Stop_Propulsion();												// On arrte les moteurs
						Distributeur_Bleu(3);											// Prends trois balles dans le distributeur
						Commande_Rouleaux(-90, -90);									// On fait tourner les rouleaux pour  nouveau attraper les balles
						Goto_Conteneur (800);											// Va au conteneur standard
						Depose_Balles (BLEUE);											// Dpose les balles dans le conteneur
						Commande_Rouleaux(90, 90);										// On fait tourner les rouleaux pour  nouveau attraper les balles
						}
						
					break;
					
					
					
					
					
		case 2 :  	printf ("Ph 4b: Distri ad\n");										// Config 2: on va lui prendre des balles
		
					GotoXY_Propulsion(500,750,100);										// 
					while (	Etat_Propulsion ()!='a' );	
					
					Angle_Propulsion (PI,25);											// S'oriente perpendiculaire  la largeur de la table ...
					while (Etat_Propulsion ()!='a' && NbBalles_Barillet(BLANCHE)<2);	// ... pour tre face au distributeur
	
					GotoXY_Propulsion(0,750,25);										// Longe le conteneur pour venir defendre
					while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 						// Soit on a les switchs
							&& Etat_Propulsion()!='g');									// Soit on est bloqu
					
					if (Recal_Avant())
						Force_Propulsion(234, Y_Propulsion (), 3141);
					
					Distributeur_Blanc_Rouge (2,0);	
					Goto_Cote_Bleu_Arriere ();
					
					
					if (NbBalles_Barillet(BLEUE)<3 && NbBalles_Barillet(TOUTES)<5) 		// Si on a pas les trois balles bleues et qu'il reste de la place
					{
					
						Angle_Propulsion (-PI/2.0,25);									// S'oriente en face du distributeur
						while (Etat_Propulsion ()!='a');
		
						GotoXY_Propulsion(2300, 0, 50);									// Avancer vers le distributeur en avant
						while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
								Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
								Y_Propulsion ()>440 &&									// ... ou on est proche du distributeur
								NbBalles_Barillet(BLEUE)<3);							// ... ou si on a les 3 balles blanches
						Stop_Propulsion();												// On arrte les moteurs
						Distributeur_Bleu(3);											// Prends trois balles dans le distributeur
						Commande_Rouleaux(-90, -90);									// On fait tourner les rouleaux pour  nouveau attraper les balles
					}	
					
					Goto_Conteneur (800);											// Va au conteneur standard
					Depose_Balles (BLEUE);											// Dpose les balles dans le conteneur
					Commande_Rouleaux(90, 90);										// On fait tourner les rouleaux pour  nouveau attraper les balles
						
					
					break;
					
	}
	
	
	// ------------------------------------------------------------------
// Phase 5 : Tir
//	
	Goto_Cote_Bleu ();

	GotoXY_Propulsion (2650,350,60);									// Avance au point de recalage
	while (Etat_Propulsion ()!='a');

	Recal_Cote_Bleu ();													// Recale le robot en X, Y et en Psi

	GotoXY_Propulsion(2300,750,-60);									// Recule dans l'axes des distributeurs
	while (Etat_Propulsion ()!='a');
	
	Angle_Propulsion (-PI/2.0,25);									// S'oriente en face du distributeur
	while (Etat_Propulsion ()!='a');

	GotoXY_Propulsion(2300, 0, 45);									// Avancer vers le distributeur en avant
	while (	Etat_Propulsion ()!='g' &&								// On arrte si on est bloqu ...
			Etat_Propulsion ()!='a' && 								// ... ou si on est arriv (l il y a un problme !)...
			Y_Propulsion ()>440 &&									// ... ou on est proche du distributeur
			NbBalles_Barillet(BLEUE)<2);							// ... ou si on a les 3 balles blanches
	Stop_Propulsion();												// On arrte les moteurs
	Distributeur_Bleu(2);											// Prends trois balles dans le distributeur
	
	Commande_Rouleaux(-90, -90);									// On fait tourner les rouleaux pour  nouveau attraper les balles
	Commande_Canon(130);	
	
	GotoXY_Propulsion(2300,500,-100);										// 
	while (	Etat_Propulsion ()!='a' );
	
	Angle_Propulsion (-0.5,25);									// S'oriente vers le conteneur rfrigr
	while (Etat_Propulsion ()!='a');
	

	
	while (NbBalles_Barillet (BLEUE))
	{
		while (Mesure_Moyenne_Canon(50) < 127 || Mesure_Moyenne_Canon(50)>133); 
		TirBalle_Barillet( BLEUE );
		Delay10KTCYx(255);
	}
	
	Commande_Canon(0);
	
	
	
	Goto_Conteneur (1350);
	
	/*Angle_Propulsion (-PI/2.0,25);									// S'oriente dos au public
	while (Etat_Propulsion ()!='a');	

	ToutDroit_Propulsion(200,20);									// Avance de 20cm
	while (Etat_Propulsion ()!='a');	

	Angle_Propulsion (PI,30);										// S'oriente parallele au bord de l'aire de jeu
	while (Etat_Propulsion ()!='a');	

	GotoXY_Propulsion(1350,1750,-50);								// Longe le conteneur pour venir defendre
	while (	Etat_Propulsion ()!='a' &&
	Etat_Propulsion ()!='g');	

	Angle_Propulsion (-PI/2.0,25);									// S'oriente dos au public
	while (Etat_Propulsion ()!='a');	

	ToutDroit_Propulsion(700,-20);									// Recule sur le bord ...
	while ( !(IO_Sw_Gauche () && IO_Sw_Droit ()) &&					// ... jusqu' ce qu'on ait les deux switchs ...
			Etat_Propulsion ()!='a' &&								// ... ou que l'on soit arriv ...
			Etat_Propulsion ()!='g');								// ... ou que l'on soit bloqu.
			
		*/

	
	 

